#include "Key.h"

using namespace std;

/*
 *
 */
Key::Key(DiagInterface &diag, int col, int row, unsigned char scancode,
        QWidget *parent):
    QWidget(parent),
    diag(diag),
    col(col),
    row(row)
{
    QFont f = font();
    f.setStyleHint(QFont::Monospace);
    f.setFamily("");
    f.setPointSize(10);
    setFont(f);

    int cmbIdx = -1;
    scancodeCombo = new QComboBox;
    for (unsigned char i = 0x00; i < 0xff; i++)
    {
        string scS = scancodeName(i);
        if (scS.empty())
            continue;

        scancodeCombo->addItem(QString::fromStdString(scS), i);
        if (i == scancode)
            cmbIdx = scancodeCombo->count() - 1;
    }
    if (cmbIdx >= 0)
        scancodeCombo->setCurrentIndex(cmbIdx);

    QVBoxLayout *vbox = new QVBoxLayout;
    vbox->addWidget(scancodeCombo);
    vbox->setContentsMargins(0, 0, 0, 0);

    setLayout(vbox);

    connect(scancodeCombo, SIGNAL(currentIndexChanged(int)),
            SLOT(scancodeComboIndexChanged(int)));
}

/*
 *
 */
unsigned char Key::scancode(void)
{
    return scancodeCombo->itemData(scancodeCombo->currentIndex()).toInt();
}

/*
 *
 */
void Key::setPressed(bool val)
{
    if (pressed == val)
        return;

    pressed = val;
    update();
}

/*
 *
 */
void Key::paintEvent(QPaintEvent *event)
{
    if (pressed)
    {
        QPainter painter(this);
        painter.fillRect(rect(), Qt::darkGray);
    }
    else
        QWidget::paintEvent(event);
}

/*
 *
 */
void Key::scancodeComboIndexChanged(int)
{
    diag.setScancode(col, row, scancode());
}
